#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: dominoPrefsLib.tcl,v 1.1 2004/09/06 14:47:13 cguirao Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# fsogni  30/01/98  created
#
#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

#Initialize the preference panel
proc dominoPrefsInitX {} {
    global gvar env cv
    
    
    # window manager's default action.
    
    #windowOnTop .dominoPrefs
    set _top_level [winfo toplevel $gvar(prefsCV)]
    wm protocol $_top_level WM_DELETE_WINDOW "bell"
    
    #Trap signals
    signal trap {INT QUIT TERM} {
	htInfo "Please use Cancel to close the panel."}
    signal trap {CONT} "wm deiconify ."
    
    defaultVARS
    $gvar(prefsCV).selTableWdg config -itemList $gvar(tableItemList)
    $gvar(prefsCV).selTableWdg config -itemValue $gvar(tableItemValue) 
}

#Parse the preferences and accept them (in case they're valid).
proc dominoAcceptPrefs {} {
    global gvar cv env
    
    if {![dominoCheckVariables]} {
	
	.dataSubscriber.top.wdg.can.dominoStartWdgRAW enable
	.dataSubscriber.top.wdg.can.dominoStartWdgRED enable
	foreach gvar(fileType) { RAW RED} {
	    if {!$gvar(alreadyRunning-$gvar(fileType))} {
		.dataSubscriber.top.wdg.can.dominoStopWdg$gvar(fileType) disable
		.dataSubscriber.top.wdg.can.dominoNttWdg$gvar(fileType).frame.uifBitmap configure -background grey 
	    }
	}
	.dataSubscriber.top.wdg.can.dominoConfigWdg enable
	dominoPrefsClose
    } else { return }
}

#Reset the translation buttons.
proc dominoCleanCorrfits {} {
    global gvar

    set gvar(dominoTrans) 0 
    set gvar(dominoRename) 0 
    #set gvar(dominoBrowseKeyword) ""
    #set gvar(dominoBrowseKeywordClean) ""
    #set gvar(selCleanTable) ""
    
}

#Perform a check on the inserted options.
proc dominoCheckVariables {} {
    global gvar env popflag
    

    ################# Perform checks on the  date ##########################    
    set currentDate [expr {[clock seconds] - 43200}]
    if {$gvar(dominoTo) != "" && $gvar(dominoFrom) == ""} {
	htInfo "Please fill in the 'From:' field."
	return 1}
    
    
    if {$gvar(dominoFrom) != ""} {
	set fromDate [checkDateFormat $gvar(dominoFrom)]
	if {$fromDate == 0} {
	    htInfo "Error: The 'From:' date is  not correct"
	    return 1
	}
	if {$fromDate > $currentDate} { 
	    htInfo "Error: The 'From:' date is in the future.\n(Remember: day changes at midday)."
	    return 1
	}
	set gvar(dominoFrom) [addZeroesToDate $gvar(dominoFrom)]
    }
    
    if {$gvar(dominoTo) != ""} {
	set toDate            [checkDateFormat $gvar(dominoTo)]
	if {$toDate == 0} {
	    htInfo "Error: The 'To:' date is not correct"
	    return 1
	}
	if {$toDate > $currentDate} {
	    htInfo "Error: The 'To:' date is in the future\n(Remember: day changes at midday)."
	    return 1
	}
	if {$fromDate > $toDate} {
	    htInfo "Error: The 'To:' date must be after 'From:'"
	    return 1
	}    
	
	set gva(dominoTo) [addZeroesToDate $gvar(dominoTo)]
    }

    set gvar(dominoFrom-$gvar(fileType)) $gvar(dominoFrom)
    set gvar(dominoTo-$gvar(fileType)) $gvar(dominoTo)	     
    
#################### End Check of Date ###################################
    
    if {$gvar(dominoRename) == 1 && $gvar(dominoRenameTo) == ""} {
		htInfo "You chose to rename file, but didn't specify a filename"
	return 1
    } else { regsub -all " " $gvar(dominoRenameTo) "_" gvar(dominoRenameTo) }
    
    if {$gvar(postCommand) == 1 && $gvar(postCommandLine) == ""} {
	htInfo "You selected postcommand but forgot to insert one"
	return 1}
    
    if {$gvar(postCommandLine) != ""} {
		htPopUp "WARNING!\nYou will use Postcommand at your own risk.\nIs that ok ?" 1 0 1
		if {$popflag == 0} {
			set gvar(postCommand) 0
			set gvar(postCommandLine) ""
			$gvar(prefsCV).dominoPostComWdg3 disable
			return 1}
    }
    
    foreach gvar(fileType) {RAW RED} {
	set gvar(dominoFrom-$gvar(fileType))          $gvar(dominoFrom)
	set gvar(dominoTo-$gvar(fileType))            $gvar(dominoTo)
	set gvar(dominoRename-$gvar(fileType))        $gvar(dominoRename)
	set gvar(dominoRenameTo-$gvar(fileType))      $gvar(dominoRenameTo)
	set gvar(dominoBrowseKeyword-$gvar(fileType)) $gvar(dominoBrowseKeyword)
	set gvar(dominoTrans-$gvar(fileType))         $gvar(dominoTrans)
	set gvar(optTable-$gvar(fileType))            $gvar(optTable)
	set gvar(postCommand-$gvar(fileType))         $gvar(postCommand)
	set gvar(postCommandLine-$gvar(fileType))     $gvar(postCommandLine)
	set env(DHS_HOST)                             $gvar(DHS_HOST-$gvar(fileType))
	set env(DHS_CONFIG)                           $gvar(DHS_CONFIG-$gvar(fileType))
    }
    return 0
}

#Create a list of the nights between from and to
# proc countNights {from to} {
#     global gvar 

#     set splitDate [split $from "-"]
#     set year  [lindex $splitDate 0]
#     set month [lindex $splitDate 1]
#     set day   [lindex $splitDate 2]
#     set fromS [clock scan "$month/$day/$year" -gmt 1]
    
#     set splitDate [split $to "-"]
#     set year  [lindex $splitDate 0]
#     set month [lindex $splitDate 1]
#     set day   [lindex $splitDate 2]
#     set toS [clock scan "$month/$day/$year" -gmt 1]
    
#     set gvar(dateList) $from
#     while {$fromS != $toS} {
# 	set fromS [expr {$fromS + 86400}]
# 	set newDate [clock format $fromS -format %Y-%m-%d]
# 	lappend gvar(dateList) $newDate
# 	#puts "fromS = $fromS -- toS = $toS -- Date: $newDate "
#     }
# }


proc addZeroesToDate {date} {

    set timeString ""
    if {[string match "*T*" $date]} {
	set splitDate [split $date "T"]
	set date [lindex $splitDate 0]
	set time [lindex $splitDate 1]
	set splittedTime [split $time ":"]
	set hours    [leadingZero [lindex $splittedTime 0]]
	set minutes  [leadingZero [lindex $splittedTime 1]]
	set seconds  [leadingZero [lindex $splittedTime 2]]
	set timeString "$hours:$minutes:$seconds"
    }
    
    set splittedDate [split $date "-"]
    set year  [lindex $splittedDate 0]
    set month [leadingZero [lindex $splittedDate 1]]
    set day   [leadingZero [lindex $splittedDate 2]]
    set goodDate "$year-$month-$day"
    if {$timeString != ""} {
	append goodDate "T$timeString"
    }
 
    if {[catch {set date [clock scan "$month/$day/$year $timeString"]}]} {
	return 0 
    } else { 
	return $goodDate
    }
}


proc checkDateFormat {date} {
    
    
    set timeString ""
    if {[string match "*T*" $date]} {
	set splitDate [split $date "T"]
	set date [lindex $splitDate 0]
	set time [lindex $splitDate 1]
	set timeString "$time"
    }
    
    set splittedDate [split $date "-"]
    set year  [lindex $splittedDate 0]
    set month [lindex $splittedDate 1]
    set day   [lindex $splittedDate 2]
    
    if {[string length $year] < 4} {
	return 0
    }
    if {[catch {set date [clock scan "$month/$day/$year $timeString"]}]} {
	return 0 
    } else { 
	return $date
    }
}

proc leadingZero {digit} {
    
    if {$digit == ""} { 
	return "00"
    }
    
    set length [string length $digit]
    if {$length < 2} {
	return "0$digit"
    } else {
	return $digit
    }
}


#Check the date format online.
proc checkDate {newKey var Wdg} {
    global gvar cv env
    
    #I do this to trap Delete and act like BackSpace
    if {[string compare $newKey "Delete"] == 0} {
		set   gvar($var) [string range $gvar($var) 0 [expr  {[string length $gvar($var)] -2}]]
	return
    }

    if {[string compare $newKey "BackSpace"] == 0} { return }
    
    
    if {![string match {[0-9]} $newKey] && 
	![string match "minus" $newKey] } {
	if {$gvar($var) == "" } { 
	    after 15 "set gvar($var) {} "
	    set newKey ""
	} else { set newKey ""}
    }	
    
    if {$newKey == "minus"} {set newKey "-"}
    if {[string length $gvar($var)] == 10} {set newKey ""} 
    
    set tmpkey $gvar($var)$newKey
    update
    after 10 set gvar($var) $tmpkey	
    after 10 $Wdg.uifEntry icursor end
}

#Close the prefs panel
proc dominoPrefsClose {} {
    
    panClosePanel no .dominoPrefs
    wm deiconify .
}

#Read the configuration file and set the defaults
proc dominoDefaults {} {
    global gvar env 

    if {[file exists $env(HOME)/.dataSubscriberConfig]} {
	ScanConfigFile $env(HOME)/.dataSubscriberConfig gvar
    }
    
    # List with all Domino Preferences Parameters. This list at the same time
    # defines the default values for each paramater
    #set gvar(currentDate) [clock format [expr [clock seconds] - 43200]  -format "%Y-%m-%d" -gmt 1]
    set gvar(currentDate) [clock format [expr {[clock seconds] - 43200}]  -format "%Y-%m-%d"]

    set gvar(prefsList) "\
	            {DHS_HOST-RAW     {$env(OlasWS)}} \
                {DHS_CONFIG-RAW   {archeso@$env(OlasWS):/data/msg}} \
                {DHS_DATA-RAW     {/data/raw}} \
	            {StartScript-RAW  {dhsSubscribeControl start userRaw}} \
                {DHS_HOST-RED     {$env(QcWS)}} \
                {DHS_CONFIG-RED   {quality@$env(QcWS):/data/msg}} \
                {DHS_DATA-RED     {/data/reduced}} \
                {StartScript-RED  {dhsSubscribeControl start userReduced}} \
                {transTables      {{Moon $env(DFS_GUI_CONFIG)/MoonCalc.ftt} {Spectroscopy $env(DFS_GUI_CONFIG)/spectroscopy.ht} {Imaging $env(DFS_GUI_CONFIG)/imaging.ht}}}"
    set savePrefs 0
    foreach el $gvar(prefsList) {
	set key [lindex $el 0]	
	if {![info exists gvar($key)]} {
	    set value [lindex $el 1]
	    set gvar($key) $value
	    htDebug "Set gvar($key) = $value" 3
	    set savePrefs 1
	}
    }

    set list  ""
    set value ""
    foreach table $gvar(transTables) {
	set list  [lindex $table 0]
	set value [lindex $table 1]
	if {[file exists $value]} {
	    lappend gvar(tableItemList)  $list 
	    lappend gvar(tableItemValue) $value
	}
    }
    

    defaultRAW
    defaultRED
    set gvar(startFlag-RAW) 0
    set gvar(startFlag-RED) 0
    if {$savePrefs} {dominoSavePrefs}
}     


proc defaultVARS {} {
    global gvar env ht
    
    set gvar(dominoFrom)      $gvar(dominoFrom-$gvar(fileType))
    set gvar(dominoTo)        $gvar(dominoTo-$gvar(fileType))
    set gvar(dominoRename)    $gvar(dominoRename-$gvar(fileType))
    set gvar(dominoRenameTo)  $gvar(dominoRenameTo-$gvar(fileType))
    set gvar(dominoBrowseKeyword) $gvar(dominoBrowseKeyword-$gvar(fileType))
    set gvar(dominoTrans)     $gvar(dominoTrans-$gvar(fileType))
    set gvar(optTable)        $gvar(optTable-$gvar(fileType))
    set gvar(postCommand)     $gvar(postCommand-$gvar(fileType))
    set gvar(postCommandLine) $gvar(postCommandLine-$gvar(fileType))
    
    $gvar(prefsCV).selTableWdg config -itemList $gvar(optItemList-$gvar(fileType))
    $gvar(prefsCV).selTableWdg config -itemValue $gvar(optItemValue-$gvar(fileType))
    set gvar(optTable)        $gvar(optTable-$gvar(fileType))
    if {$gvar(dominoRename) != 1} {$gvar(prefsCV).dominoRenameWdg3 disable}
    if {$gvar(dominoRename) != 2} {$gvar(prefsCV).dominoPrefs-wdg1 disable}
    if {$gvar(dominoTrans) != 1 } {$gvar(prefsCV).selTableWdg disable
	$gvar(prefsCV).dominoTransWdg2 disable}
    if {$gvar(postCommand) != 1} {$gvar(prefsCV).dominoPostComWdg3 disable}
}



proc defaultRAW {} {
    global gvar env

    set gvar(dominoFrom-RAW)      $gvar(currentDate)
    set gvar(dominoTo-RAW)        ""
    set gvar(dominoRename-RAW)    0
    set gvar(dominoRenameTo-RAW)  "MyPrefix"
    set gvar(dominoBrowseKeyword-RAW) "HIERARCH ESO OBS NAME"
    set gvar(dominoTrans-RAW)     0
    set gvar(optTable-RAW)        [lindex $gvar(tableItemValue) 0]
    set gvar(postCommand-RAW)     0
    set gvar(postCommandLine-RAW) ""
    set gvar(optItemList-RAW)     $gvar(tableItemList)
    set gvar(optItemValue-RAW)    $gvar(tableItemValue)
    set gvar(ID-RAW) "RAW::$env(HOST)::$gvar(DHS_HOST-RAW)"
    htDebug "The RAW ID is: $gvar(ID-RAW)" 1 
}

proc defaultRED {} {
    global gvar env 

    set gvar(dominoFrom-RED)      $gvar(currentDate)
    set gvar(dominoTo-RED)        ""
    set gvar(dominoRename-RED)    0
    set gvar(dominoRenameTo-RED)  "MyPrefix"
    set gvar(dominoBrowseKeyword-RED) "HIERARCH ESO OBS NAME"
    set gvar(dominoTrans-RED)     0
    set gvar(optTable-RED)        [lindex $gvar(tableItemValue) 0]
    set gvar(postCommand-RED)     0
    set gvar(postCommandLine-RED) ""
    set gvar(optItemList-RED)     $gvar(tableItemList)
    set gvar(optItemValue-RED)    $gvar(tableItemValue)
    set gvar(ID-RED) "RED::$env(HOST)::$gvar(DHS_HOST-RED)"
    htDebug "The RED ID is: $gvar(ID-RED)" 1
}


#Save the preferences in $HOME/.dataSubscriberConfig
proc dominoSavePrefs {} {
    global gvar env cv


    #In this version only defaults will be written on disk
    #and only if the configuration file is missing.
    
    set file [open $env(HOME)/.dataSubscriberConfig w]
    set fileBuf "\
	    ###########################################################\n\
	    #                                                         #\n\
	    #              THE ARCHIVE DATA SUBSCRIBER                #\n\
	    #                                                         #\n\
	    #              dataSubscriber Preferences                 #\n\
	    #                                                         #\n\
	    #              Don't edit this file manually.             #\n\
	    #                                                         #\n\
	    #              Edit it via the dataSubscriber.            #\n\
	    #                                                         #\n\
	    ###########################################################\n\n"
    set prefFormat "%-24s: %s\n"    
    foreach el $gvar(prefsList) {
	set key [lindex $el 0]	
	set value $gvar($key)
	set line [format $prefFormat $key $value]
	set fileBuf "${fileBuf}$line"
    }
    set fileBuf "${fileBuf}\n\n\# --- oOo ---\n"    
    puts $file $fileBuf
    htDebug "Buffer = $fileBuf" 3
    close $file
}

#Call this if you want to use a translation table
proc checkImportHt {} {
    global gvar

    set gvar(postCommand) 0 
    if {$gvar(selCleanTable) == ""} {
	wm withdraw .dominoPrefs
	dominoImportHt}
}

#Actually call the Header Translator.
proc dominoImportHt {} {
    global gvar

    if {$gvar(dominoHtFlag) == 0} {
	set gvar(dominoHtFlag) 1
	wm withdraw .dominoPrefs
	dominoImportPanel ht}
}


proc dominoUpdateOptions {} {
    global gvar

    set itemList  [$gvar(prefsCV).selTableWdg cget -itemList]
    set itemValue [$gvar(prefsCV).selTableWdg cget -itemValue]
    set index     [lsearch -exact $itemList $gvar(selCleanTable)]

    if {$index == -1} {
	set gvar(optItemList-$gvar(fileType)) "$itemList $gvar(selCleanTable)"
	set gvar(optItemValue-$gvar(fileType)) "$itemValue $gvar(selTable)"
	$gvar(prefsCV).selTableWdg config -itemList $gvar(optItemList-$gvar(fileType))
	$gvar(prefsCV).selTableWdg config -itemValue $gvar(optItemValue-$gvar(fileType))
	 }

    set gvar(optTable) $gvar(selTable)
    
}


#Check the login information (program ID and name) and close the panel.
proc subInfoAccept {} {
    global gvar 
    
    if {$gvar(programID) == "service" } {
	set gvar(serviceFlag) 1
    } else {
	set gvar(serviceFlag) 0
	set gvar(programID) [string toupper $gvar(programID)]
	if {$gvar(programID) == ""} {htInfo "Please insert the Program ID."; return }
	set re {^[0-9]?[0-9][0-9]\.[A-Z]-[0-9][0-9][0-9][0-9](\([A-Z]\))?$}
	if {![regexp $re $gvar(programID)]} {htInfo "Invalid Program ID" ; return }
    }
    
    if {$gvar(obsName) == ""} {htInfo "Please insert your name."; return }
    set gvar(initFlag) 0
    wm title . "Subscription for $gvar(obsName) - $gvar(programID)"
    panClosePanel no .subInfo
    wm deiconify .
}


#
# ___oOo___
