#!/bin/bash 
#
# ccsLite: starts/stops the ccsLite environment
#
# chkconfig: 2345 98 02
#
# description: Starts and stops the ccsLite environment
#
# processname: many
#

# Source function library.

UNAMEN=`hostname`
case $UNAMEN in
  w*) RTAPENV=$UNAMEN ;;
  *)  RTAPENV=w$UNAMEN ;;
esac
RTAPENV=`echo $RTAPENV | sed 's/^\(.......\).*/\1/'`

OWNER=XXXXXX

#
# Check the OWNER user exist 
#
id $OWNER > /dev/null
if [ $? -ne 0 ]; then  
  exit 1
fi

# Source function library.
. /etc/rc.d/init.d/functions 

RETVAL=0

start() {
        echo -n $"Starting ccsLite: "
	daemon --user $OWNER  vccEnvStart -e $RTAPENV -t QSEMU
        RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && touch /var/lock/subsys/ccsLite
        return $RETVAL
}

stop() {
        echo -n $"Shutting down ccsLite: "
	daemon --user $OWNER  vccEnvStop -e $RTAPENV -t QSEMU
        RETVAL=$?
        echo
	[ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/ccsLite
        return $RETVAL
}


# See how we were called.
case "$1" in
  start)
	start
	;;
  stop)
	stop
	;;
  status)
	status ccsScheduler
	status ccsCmdServer
	status qsemu
	status msgServer
	;;
  restart)
	stop
	start
	;;
  *)
	echo "Usage: $0 {start|stop|status|restart}"
	exit 1
esac

exit $RETVAL
