#!/bin/bash 
#
# dfslog: starts/stops the dfslog server
#
# chkconfig: 2345 96 04
#
# description: Starts and stops the dfslog daemon
#
# processname: dfslogd
#

# Source function library.

OWNER=XXXXXX

#
# Check the OWNER user exist 
#
id $OWNER > /dev/null
if [ $? -ne 0 ]; then  
  exit 1
fi

# Source function library.
. /etc/rc.d/init.d/functions 

RETVAL=0

start() {
        echo -n $"Starting dfslogd: "
	daemon --user $OWNER ~flowmgr/dfs/bin/dfslogControl start 
        RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && touch /var/lock/subsys/dfslogd
	/etc/init.d/syslog restart >/dev/null  2>&1
        return $RETVAL
}

stop() {
        echo -n $"Shutting down dfslogd: "
        killproc dfslogd
        RETVAL=$?
        echo
	[ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/dfslogd
	rm -f /tmp/dfslogPipe
	/etc/init.d/syslog restart >/dev/null 2>&1
        return $RETVAL
}


# See how we were called.
case "$1" in
  start)
	start
	;;
  stop)
	stop
	;;
  status)
	status dfslogd
	;;
  restart)
	stop
	start
	;;
  *)
	echo "Usage: $0 {start|stop|status|restart}"
	exit 1
esac

exit $RETVAL
