package org.eso.ohs.core.dbb.client;

import org.eso.ohs.core.utilities.OHSGlobalVariables;

/**
 * A special data type to be used in the database browsers built for
 * P2PP and the OT; and in general, by all browsers dealing with
 * Right Ascension stored in the OB repository. <BR>
 *
 * This was a private class of p2pp/DbaseWindow.java. Moved to
 * utilities for want of a better place; in fact the DBB package
 * should be moved up one level, from org/eso/ohs/dbb to org/eso/dbb,
 * and this class should then go into some OHS-specific dbb directory.
 *
 * <p>
 * $Id: DbaseRA.java,v 1.4 2005/04/15 17:41:52 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 * @author Tim Canavan
 * @author A M Chavan, 03-Feb-01: moved class out of DbaseWindow.java */

public class DbaseRA extends DbaseAngle {

    public DbaseRA() {
	super();
    }

    public String fromDatabaseData(Object value) {
	int ivalue = ((Integer)value).intValue();
	
	ivalue = ivalue/OHSGlobalVariables.DEGREES_PER_HOUR ;
	
	return super.fromDatabaseData( new Integer( ivalue ));
    }
    
    public Object toDatabaseData(String value) {
	int ivalue = ((Integer)super.toDatabaseData(value)).intValue();
	return new Integer(ivalue*OHSGlobalVariables.DEGREES_PER_HOUR);
    }
}





