package org.eso.ohs.core.dbb.client;

// $Id: DbbDataType.java,v 1.1 2004/02/17 11:16:24 tcanavan Exp $

/**
 * This inteface define a specific behavior for database
 * types. Sometimes the database data have a different format from the
 * values to be displayed. This interface declares the methods to be
 * implemented to operate the format conversions.
 *
 * @author Carlo Boarotto, ESO 20-Jul-1999
 */

import java.io.Serializable;

public interface DbbDataType extends Serializable {

   /**
     * @return the preferred datatype length (number of characters to
     *  be displayed) 
     */
    public int getDataTypeLength();

    /** @return The java Class associated with the displayed data */
    public Class getDataType();

    /** @return The java Class associated with the database data */
    public Class getDatabaseType();

    /**
     * Convert database format into display format
     * @param value Database value
     */
    public String fromDatabaseData(Object value);

    /**
     * Convert display format into database format
     * @param value Display value
     */
    public Object toDatabaseData(String value);
}
