package org.eso.ohs.core.dbb.client;

import javax.swing.JTextField;

import org.eso.ohs.core.dbb.sql.DbbSqlChunk;
import org.eso.ohs.core.gui.models.MoonAngularModel;

public class DbbMoonAngularTextField extends DbbTextField {

  public static final int CONVERSION_VALUE = 3600000;

  /** Create a DbbTextField object.
   * 
   * @param labeltext	Label text to be displayed.
   * @param chunk	DbbSqlChunk object
   *  */
  public DbbMoonAngularTextField(String labeltext, 
				 DbbSqlChunk chunk) {

    super(labeltext, chunk);
    JTextField tf = (JTextField)widget_;
    tf.setDocument(new MoonAngularModel());
  }

  /** 
   * Get the widget value.
   *
   * @return The currently displayed string value. 
   */
  public String get() {

    String str = ((JTextField) widget_).getText();

    if(str.equals(""))
      return str;

    int val = Integer.parseInt(str);
    val = val * CONVERSION_VALUE;
    return(Integer.toString(val));
  }
}

