package org.eso.ohs.core.dbb.client;

import java.text.DateFormat;
import java.text.ParseException;
import java.util.Date;

import org.apache.log4j.Logger;

public class StarcatDate implements DbbDataType {
private static final String rcsid = "$Id: StarcatDate.java,v 1.1 2004/11/15 08:30:57 ddorigo Exp $";  
  private static Logger stdlog_ = 
	Logger.getLogger( StarcatDate.class );
  
    static final long STARCAT_TO_UNIX_OFFSET = 315532800;
    static DateFormat dateFmt = DateFormat.getDateInstance(DateFormat.MEDIUM);
    private final static String DEFAULT_ = "------------------";

    public static Date fromStarcatDate(long val) {
		long time = (val + STARCAT_TO_UNIX_OFFSET) * 1000;
		Date d = new Date(time);
		return d;
    }


    public int getDataTypeLength() {
	return DEFAULT_.length();
    }
    
    public Class getDataType() {
	return String.class;
    }

    public Class getDatabaseType() {
	return Integer.class;
    }

    public String fromDatabaseData(Object value) {
		long date = 0;
    	
     	Integer val = (Integer)value;
		date = val.longValue();
    	
		
		String ret = dateFmt.format(fromStarcatDate(date));  
	
		return ret;
    }

    public Object toDatabaseData(String value) {

		long val = 0;
	    
		if(value != null) {
		    value = value.trim();
		    try {
			Date d = dateFmt.parse(value);
			val = convertDateToStarCatLong(d);
		    }
		    catch (ParseException e) {
			if(!value.equals("true") && !value.equals("false")) {
			   stdlog_.warn("DATE CONV.ERR. while converting " +
					       value,e);
			}
		}
	}

	return(new Long(val));
    }


	public static long convertDateToStarCatLong(Date d) {
		long val;
		long time = d.getTime();
		val = time / 1000 - STARCAT_TO_UNIX_OFFSET;
		return val;
	}

}
