package org.eso.ohs.core.dbb.htmlclient;

import org.eso.ohs.core.dbb.sql.DbbSqlChunk;


/**
 * This is an implementation of the DbbHtmlWidget abstract class,
 * defining a text field.
 * <br>
 * @author amchavan, ESO 09-Dec-2003
 * @version $Revision: 1.1 $
 */

// $Id: DbbHtmlFormattedTextField.java,v 1.1 2004/03/02 12:40:07 janwunah Exp $

public class DbbHtmlFormattedTextField extends DbbHtmlWidget {

	/** Deafult width for text widgets */
	public final static int COLUMNSIZE = 15;

	public static final String cvsID_ =
		"$Id: DbbHtmlFormattedTextField.java,v 1.1 2004/03/02 12:40:07 janwunah Exp $";
		
	/**
	 * Create an instance associated with a specific chunk. --- constructor added by Judith
	 * @param chunk
	 */		
	public DbbHtmlFormattedTextField(String labeltext, DbbSqlChunk chunk) {
		super(labeltext, chunk);
		setDefault( "" );	
	}//Constructor
	 
	//- added by Judith 24 Feb. 2004 -- note for 1 March -- this will not 
	//work have to add JavaScript in the render method to get it to work on the web
	
	

	/**
	 * Create an instance associated with a specific chunk.
	 *
	 * @param chunk DbbSqlChunk object.
	 
	public DbbHtmlFormattedTextField( DbbSqlChunk chunk ) {
		this(chunk.getLabel(), chunk);
	}
	*/

	/**
	 * Create an instance, with a specific label, associated with a
	 * specific chunk
	 *
	 * @param labeltext Label text to be displayed.
	 * @param chunk     DbbSqlChunk object.
	 
	public DbbHtmlFormattedTextField(String labeltext, DbbSqlChunk chunk) {
		super(labeltext, chunk);
		setDefault( "" );
	}
	*/

	/** Implementation of the abstract method */
	public String render( int indentLevel ) {
        String     name = getName(); 
		StringBuffer sb = new StringBuffer();
		
		sb
			.append(indentSpaces(indentLevel))
			.append("<td> ")
			.append(getLabel())
			.append(" </td>\n")
		
			.append(indentSpaces(indentLevel))
			.append("<td> ")
			.append("<input type=\"text\" name=\"")
			.append( name )
			.append("\">")
			.append(" </td>\n");
		
		return sb.toString();
	}
    
    /**
     * Set the widget's value (implementation of the abstract method).
     *
     * @param val Can be any string.
     */
    public void set( String val ) {

        DbbSqlChunk c = getSqlChunk();
        c.setActive( val.length() > 0 );
        c.setValue( val );
        value_ = val;
    }
}
