package org.eso.ohs.core.gui.widgets;

import java.awt.Component;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPasswordField;

/**
 * Excepts the user id and password and returns a flag to
 * the caller to determinew what action has taken place.
 * <p>
 * $Id: AuthenticationDialog.java,v 1.1 2004/02/17 10:35:21 tcanavan Exp $
 * <br>
 * @author Tim Canavan
 * <br>ChangeLog: Bob Kemp
 */

public class AuthenticationDialog extends SimpleInputDialog {

    /** 
     * Password entry field
     */
    private JPasswordField passwordField_ = new JPasswordField(10);

    /**
     * Create a password dialog
     * @param frm Frame for dialog
     * @param title title of dialog
     */
    public AuthenticationDialog(JFrame frm, String title,
				    String message, String username) {
	super(frm, title);

	initialise(message,
		    new String[] { "User name ", "Password " },
		    new Component[] { new JLabel(username), passwordField_ }
	);

	passwordField_.setEchoChar('-');			
    }

    protected void requestInitialFocus() {
	passwordField_.requestFocus();
    }

    /**
     * Get the password the usser has entered
     */
    public String getPassword() {
	return new String(passwordField_.getPassword());
    }

}
