package org.eso.ohs.core.utilities;

/**
 * A generic interface to a tree path for use with the GTreeModel interface.
 * The interface is intended to be flexible enough to allow easy implementation
 * and application (e.g for use in Config information handling with JDOM).
 *
 * Please see GTreeModel for other details.
 *
 * @author Nick Kornweibel for ESO.
 */

public interface GTreePath {

    /**
     * @return this path as an array of GTreeNode objects.
     * With element 0 being the root of the tree.
     */
    public GTreeNode[] getPath();
}
