/*
 * Created on Dec 7, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.eso.ohs.dfs;


import org.eso.ohs.core.utilities.Convert;
import org.eso.ohs.instruments.Instrument;
import org.eso.ohs.instruments.InstrumentConstraintConfig;
import org.eso.ohs.instruments.InstrumentList;
import org.eso.ohs.instruments.ReadmeAttribute;

/**
 * Class ReadmeFileReport
 *
 * TODO Javadoc
 *
 * @version $Revision: 1.25 $
 * @author tcanavan, Dec 7, 2004
 */

// $Id: ReadmeFileReport.java,v 1.25 2005/04/27 12:32:47 tcanavan Exp $
public class ReadmeFileReport {
    
    private static  String convertToBooleanString(boolean value) {
        if(value == true)
            return "Y";
        return "N";
    }
    
    public static String readmeFileReport(ObservingRun obsRun,boolean usdEnabled) {
        StringBuffer buf = new StringBuffer();
        USDReadmeDatails details = obsRun.getReadme().getUsdReadmeFileDetails();
        boolean getusd=true;
        if(!usdEnabled) {
            buf.append("Observatory Notes\n");
            buf.append("=================\n");
            if(details.getObservatoryNotes() != null)
                buf.append(details.getObservatoryNotes());
            buf.append("\n\n");
            if(!details.getReviewStatus().equals(USDReadmeDatails.OK)) {
                buf.append("USD File not available yet\n");
                buf.append("\n");
                getusd=false;
            }
        }
        if(getusd) {
            setUSDString(obsRun, buf, details,usdEnabled);
        }         
        buf.append("Total number of Observation Blocks : " + details.getTotalOBs()+ "\n"); 
        buf.append("Total number of Calibration Blocks : " + details.getTotalCBS()+ "\n");
        buf.append("\n");        
        buf.append("Constraint Sets\n");
        buf.append("===============\n");
        ConstraintSetDTO [] dtos = details.getCsDtos();       
        buf.append("Airmass Sky Transparency Seeing FLI Moon Distance OB Count\n");
        for(int i=0;i<dtos.length;i++) {
            buf.append(dtos[i].getAirmass() +         "   ");
            buf.append("      " + dtos[i].getSkyTransparency() + "           ");
            buf.append(dtos[i].getSeeing()          + "  ");
            buf.append(dtos[i].getFractionalLunarIllumination() + "      ");
            buf.append(dtos[i].getMoonAngularDistance() + "         ");
            buf.append(dtos[i].getCount() + "      ");
            buf.append("\n");
        }
        buf.append("\n");
        Readme readme = obsRun.getReadme();
        ReadmeAttribute [] readmeAttributes = readme.getRedmeAttributes();
        for(int i=0;i<readmeAttributes.length;i++) {
            InstrumentConstraintConfig config = readmeAttributes[i].getReadmeConfig();          
            if(config.getSuperType().equals("float") ||
               config.getSuperType().equals("integer") ||
               config.getSuperType().equals("normaltext") ||
               config.getSuperType().equals("multilist") ||
               config.getSuperType().equals("emailAddressType") ||
               config.getSuperType().equals("BooleanType")) {
                String label = readmeAttributes[i].getReadmeConfig().getLabel();
                buf.append(label);
                buf.append(" : ");
                buf.append(readmeAttributes[i].getDisplayValue());
                buf.append("\n");
                for(int j=0;j<label.length();j++) {
                   buf.append("=");                    
                }
                buf.append("\n\n");

            }
        }

        for(int i=0;i<readmeAttributes.length;i++) {
            InstrumentConstraintConfig config = readmeAttributes[i].getReadmeConfig();          
            if(config.getSuperType().equals("largetext")) {
                String label = readmeAttributes[i].getReadmeConfig().getLabel();
                buf.append(label);
                buf.append("\n");
                for(int j=0;j<label.length();j++) {
                    buf.append("=");                    
                }
                buf.append("\n");                
                buf.append(readmeAttributes[i].getDisplayValue());
                buf.append("\n\n");
            }
        }
        
        for(int i=0;i<readmeAttributes.length;i++) {
            if(i==0) {
                buf.append("---------------------------Compliance Checks-----------------------------------\n\n");
            }
            
            InstrumentConstraintConfig config = readmeAttributes[i].getReadmeConfig();                      
            if(config.getSuperType().equals("ThreeStateBooleanType") ||
               config.getSuperType().equals("FourStateBooleanType")) {
                String label = readmeAttributes[i].getReadmeConfig().getLabel();
                buf.append(label);
                buf.append(" : ");                
                buf.append(readmeAttributes[i].getDisplayValue());
                buf.append("\n\n");
            }
            if(i==readmeAttributes.length-1) {
                buf.append("\n");
            }     

        }
        
        Instrument inst = InstrumentList.getInstance().getInstrument(obsRun.getInstCode(),readme.getIpVersion());
        String instLabel = inst.getLabelInstComment();
        
        boolean hasInstrumentCommentsEnabled = inst.hasInstComments();
        CommentDetails [] commentDetails = readme.getCommentArray();
        for(int i=0;i<commentDetails.length;i++) {
            buf.append("-------------------------OB Comment Details-------------------------------------\n");
            buf.append("OB ID         : " + commentDetails[i].getObId() + "\n");
            buf.append("OB Name       : " + commentDetails[i].getName()+ "\n");
            buf.append("User Priority : " + commentDetails[i].getUserPriority() + "\n");
            buf.append("User Comments : " + "\n");
            buf.append(commentDetails[i].getUserComment() + "\n");
            if(hasInstrumentCommentsEnabled)
                 buf.append(instLabel + "\n" + commentDetails[i].getInstSpecificComment() + "\n");
            buf.append("-------------------------OB Comment Details-------------------------------------\n\n");
        }
        
        ReadmeHistory [] readmeHistory = readme.getReadmeHistoryItems();
        if(readmeHistory.length > 0) {
            buf.append("-----------------------------Readme History-------------------------------------\n");
        }
        for (int i=0;i<readmeHistory.length;i++) {
            String statusChange = readmeHistory[i].getLongStatusValue();
            buf.append(readmeHistory[i].getLabel() + " has been " + statusChange + "\n");
            buf.append("Version :  " + readmeHistory[i].getVersion() + "\n");
            buf.append("Date Modifed :  " + Convert.longToISODate(readmeHistory[i].getEventTime()) + "\n");
            buf.append("Old Value :  " + readmeHistory[i].getOldValue() + "\n");
            buf.append("New Value :  " + readmeHistory[i].getNewValue() + "\n");
            buf.append("--------------------------------------------------------------------------------\n");
             
        }
        return buf.toString();
    }

    /**
     * @param obsRun
     * @param buf
     * @param details
     */
    private static void setUSDString(ObservingRun obsRun, StringBuffer buf, USDReadmeDatails details,boolean usdEnabled) {
        buf.append("USD Observing Run History Form\n");
        buf.append("==============================\n");
        buf.append("Proposal Type : " + obsRun.getProgType() + "\n");
        buf.append("PI : " + obsRun.getPIName() + "\n");
        buf.append("\n");
        String staffName = details.getUsdStaffName();
        if(usdEnabled) {
            if(staffName!=null && staffName.length() >= 0) {
                buf.append("USD Responsible : " + staffName + "\n");
            }
        }
        buf.append("USD Review State : " + details.getReviewStatusDescription() + "\n");
        buf.append("\n");
        buf.append("PREIMAGING           : " + convertToBooleanString(details.isPreImaging()) + "\n");
        buf.append("CHILEAN              : " + convertToBooleanString(details.isChilean()) + "\n");
        buf.append("SPECIAL CALIBRATIONS : " + convertToBooleanString(details.isSpecialCal()) + "\n");
        buf.append("TIME-CRITICAL        : " + convertToBooleanString(details.isTimeCritical()) + "\n");
        buf.append("CARRYOVER            : " + convertToBooleanString(details.isCarryOver()) + "\n");
        buf.append("\n");
        buf.append("Special Remarks  for MTS\n");
        buf.append("========================\n");
        buf.append(details.getSpecialComments() + "\n");
        buf.append("========================\n");
        buf.append("\n");
        buf.append("Abstract for MTS\n");
        buf.append("========================\n");
        buf.append(details.getMtsAbstract() + "\n");
        buf.append("========================\n");
        buf.append("\n");
        USGLog [] usdLog = details.getUsgLog();
        if(usdLog != null && usdLog.length > 0) {
            buf.append("Support/Change History\n");
            buf.append("======================\n");
            for(int i=0;i<usdLog.length;i++) {
                buf.append(Convert.longToISODate(usdLog[i].getLogTime()) + "\n");
                buf.append(usdLog[i].getLogMessage() + "\n\n");
            }
            buf.append("======================\n");

        }
    }

}
 
