package org.eso.ohs.dfs;

import java.io.Serializable;

import org.eso.ohs.instruments.AttribComparison;


/**
 * 
 * Class ReadmeHistory
 * This is the readme history object. Any changes made to the reamde file
 * state information or attribute information are recorded in this object.
 * TODO Javadoc
 *
 * @version $Revision: 1.7 $
 * @author tcanavan, Oct 27, 2004
 */

// $Id: ReadmeHistory.java,v 1.7 2005/01/12 09:26:45 tcanavan Exp $



public class ReadmeHistory implements Serializable {
    
    /**
     * Status of the readme history item recorded
     */
    
    private String status;
    
    /**
     * The component that made the changes to the 
     * readme file. Whether it was the ot or p2pp.
     */

        
    private String component;
    
    /**
     * The login id of the person who made the change.
     * This values is stored in eso_users. 
     */
    
    private String login;
    
    
    private String oldValue;
    
    private String newValue;
    
    
    private String name;
    
    private String label;
    
    private int version;
    
    
    private long eventTime;
    
           

    /**
     * @return Returns the component.
     */
    public String getComponent() {
        return component;
    }
    /**
     * @param component The component to set.
     */
    public void setComponent(String component) {
        this.component = component;
    }
    /**
     * @return Returns the login.
     */
    public String getLogin() {
        return login;
    }
    /**
     * @param login The login to set.
     */
    public void setLogin(String login) {
        this.login = login;
    }
    /**
     * @return Returns the status.
     */
    public String getStatus() {
        return status;
    }
    /**
     * @param status The status to set.
     */
    public void setStatus(String status) {
        this.status = status;
    }
    
    
    public String getLongStatusValue() {
        if(status.equals(AttribComparison.ATTRIB_CHANGED)) {
            return "Edited";
        }
        if(status.equals(AttribComparison.ATTRIB_ADDED)) {
            return "Added";
        }
        
        if(status.equals(AttribComparison.ATTRIB_DISCARDED)) {
            return "Deleted";
        }
        return "UNKOWN";
    }
    
    /* (non-Javadoc)
     * @see org.eso.ohs.dfs.StorableObject#postProecess()
     */
    
    
    
    public void postProecess() {
        // TODO Auto-generated method stub

    }

    /**
     * @return Returns the newValue.
     */
    public String getNewValue() {
        return newValue;
    }
    /**
     * @param newValue The newValue to set.
     */
    public void setNewValue(String newValue) {
        this.newValue = newValue;
    }
    /**
     * Get the old value. 
     * @return Returns the oldValue.
     */
    public String getOldValue() {
        return oldValue;
    }
    /**
     * @param oldValue The oldValue to set.
     */
    public void setOldValue(String oldValue) {
        this.oldValue = oldValue;
    }
    /**
     * Get the version of the item
     * @return Returns the version.
     */
    public int getVersion() {
        return version;
    }
    /**
     * Set the version of the item
     * @param version The version to set.
     */
    public void setVersion(int version) {
        this.version = version;
    }
    /**
     * @return Returns the eventTime.
     */
    public long getEventTime() {
        return eventTime;
    }
    /**
     * Set the time the event happened. 
     * @param eventTime The eventTime to set.
     */
    public void setEventTime(long eventTime) {
        this.eventTime = eventTime;
    }
    /**
     * The name of the ite,
     * @return Returns the name.
     */
    public String getName() {
        return name;
    }
    /**
     * @param name The name to set.
     */
    public void setName(String name) {
        this.name = name;
    }
    /**
     * The label text that is displayed
     * @return The label text that is displayed
     */
    public String getLabel() {
        return label;
    }

    /**
     * @param string
     */
    public void setLabel(String string) {
        label = string;
    }

}
