package org.eso.ohs.evm;

/**
 * This is the implementation interface for the EVMExecutor<->EVMImpl
 * Bridge pattern. The interface is implemented by any class that could be
 * selected as the implementation object for the EVMExecutor class.
 *
 * I guess this calss should really be called: EVMExecutorImpl...it is
 * just a little too lengthy.
 *
 * @author Nick Kornweibel
 */


import java.io.File;

import org.eso.ohs.dfs.CalibrationBlock;


public interface EVMImpl {
    public void initImpl(String[] scriptDrivers, EVMScriptFinder sf)
            throws EVMException;
    public void verifyImpl(CalibrationBlock[] obs) throws EVMException;
    public void calculateETCSImpl(CalibrationBlock [] obs) throws EVMException;
    public void setScriptTimeoutImpl(long millis);
    public long getScriptTimeoutImpl();
    public String[] getSupportedScriptExtensionsImpl();
    public void runScriptImpl(File filepath) throws EVMException;
    public void addEVMMessageListenerImpl(EVMMessageListener m);
    public void removeEVMMessageListenerImpl(EVMMessageListener m);
}
