package org.eso.ohs.instruments;

// import org.apache.log4j.*;


/**
 * InstrumentPackage class is used for holding Instrument Package objects
 *
 * $Id: InstrumentPackage.java,v 1.5 2004/04/08 12:09:52 tcanavan Exp $
 *
 */


public class InstrumentPackage {

    /** Standard log channel */
    // private static Logger stdlog_ = Logger.getLogger(InstrumentPackage.class);


    /** fields */
    private String instName_;
    private float version_;
    private String addedBy_;
    private long addedDate_;
    private String comment_;
    private byte[] instPackage_;


    /** ctor */
    public InstrumentPackage(String instName, float version) {
        instName_    = instName;
        version_     = version;
    }


    /** ctor */
    public InstrumentPackage(String instName, float version, String addedBy,
            long addedDate, String comment, byte[] instPackage) {
        instName_    = instName;
        version_     = version;
        addedBy_     = addedBy;
        addedDate_   = addedDate;
        comment_     = comment;
        instPackage_ = instPackage;
    }


    /**
     * Copy Constructor for InstrumentPackage
     * @param ip Refernce to InstrumentPackage class to be copied
     */
    public InstrumentPackage(InstrumentPackage ip) {
        instName_     = ip.instName_;
        version_      = ip.version_;
        addedBy_      = ip.addedBy_;
        addedDate_    = ip.addedDate_;
        comment_      = ip.comment_;
        instPackage_  = ip.instPackage_;
    }



    /**
     * Setter methods
     */
    public void setInstName(String newValue) {
        instName_ = newValue;
    }
    public void setVersion(float newValue) {
        version_ = newValue;
    }
    public void setAddedBy(String newValue) {
        addedBy_ = newValue;
    }
    public void setDateAdded(long newValue) {
        addedDate_ = newValue;
    }
    public void setComment(String newValue) {
        comment_ = newValue;
    }
    public void setInstPackageFile(byte[] newValue) {
        instPackage_ = newValue;
    }


    /**
     * Getter methods
     */
    public String getInstName() {
        return instName_;
    }
    public float getVersion() {
        return version_;
    }
    public String getAddedBy() {
        return addedBy_;
    }
    public long getDateAdded() {
        return addedDate_;
    }
    public String getComment() {
        return comment_;
    }
    public byte[] getInstPackageFile() {
        return instPackage_;
    }
}
