package org.eso.ohs.persistence;

/**
 * Interface for listening to changes in the directory hierarchy.
 * 
 * <p>
 * $Id: DirectoryListener.java,v 1.2 1999/10/20 08:41:54 bkemp Exp $
 */
public interface DirectoryListener extends java.util.EventListener {

    /**
     * A directory has been added.
     * 
     * @param ev    DirectoryEvent with more specific information.
     */
    public void directoryAdded(DirectoryEvent ev);

    /**
     * A directory has been moved.
     * 
     * @param ev    DirectoryEvent with more specific information.
     */
    public void directoryMoved(DirectoryEvent ev);

    /**
     * A directory has been changed.
     * 
     * @param ev    DirectoryEvent with more specific information.
     */
    public void directoryChanged(DirectoryEvent ev);

    /**
     * A directory has been removed.
     * 
     * @param ev    DirectoryEvent with more specific information.
     */
    public void directoryRemoved(DirectoryEvent ev);

}

