package org.eso.ohs.persistence;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

import org.eso.ohs.core.utilities.FileIOUtils;
import org.eso.ohs.core.utilities.TextUtils;
import org.eso.ohs.dfs.ObservingRun;
import org.eso.ohs.dfs.Readme;
import org.eso.ohs.instruments.ReadmeAttribute;


/**
 * Class ExportReadme
 *
 * TODO Javadoc
 *
 * @version $Revision: 1.5 $
 * @author tcanavan, Nov 24, 2004
 */

// $Id: ExportReadme.java,v 1.5 2004/12/07 08:50:49 ddorigo Exp $
public class ExportReadme {
    
     public boolean export(ObservingRun obsRun,File f) throws FileNotFoundException, IOException {
         Readme readme = obsRun.getReadme();
         ReadmeAttribute [] readmeAttributes = readme.getRedmeAttributes();
         StringBuffer buf = new StringBuffer();
         for(int i=0;i<readmeAttributes.length;i++) {
             String name = readmeAttributes[i].getName();
             String value = readmeAttributes[i].getValue();
             String tooltp = readmeAttributes[i].getToolTipText();  
             if(value.length() > 0) {
                 buf.append(name + " " + "\"" + TextUtils.escapedQuoteString(value) + "\"" + " #" + tooltp);                 
             } else {
                 buf.append(name + " " + "\"" + "\"" + " #" + tooltp);
             }
             buf.append("\n\n");
         }
         FileIOUtils.stringToFile(
           buf.toString(),
           f);

         return true;
     }    
}
