/*
 * Created on Mar 29, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.eso.ohs.persistence.dbase.phase2;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Properties;
import java.util.zip.CRC32;

import org.eso.ohs.core.utilities.ConnectionPool;
import org.eso.ohs.core.utilities.Convert;
import org.eso.ohs.core.utilities.FileIOUtils;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.dfs.FindingChart;

/**
 * Class UpdateFCS
 * 
 * TODO Javadoc
 * 
 * @version $Revision: 1.1 $
 * @author tcanavan, Mar 29, 2005
 */

// $Id: UpdateFCS.java,v 1.1 2005/03/30 09:56:12 tcanavan Exp $
public class UpdateFCS {
    
    
    /**
     * Update the finding chart contents when there are no other OB's in the
     * database pointing to a given finding chart.
     * @param conn
     * @param fc_id
     * @param name
     * @throws ObjectIOException
     * @throws SQLException
     */

    public static void updateFindingChartContents(
        Connection conn,
        long fcId,
        FindingChart fcChart)
        throws ObjectIOException, SQLException {
        String updText =
            "UPDATE finding_charts set fc_data = ?,fc_checksum = ?,last_mod_date = ? where fc_id = ?";

        ByteArrayInputStream instream =
            new ByteArrayInputStream(fcChart.getFcData());
        PreparedStatement stmt = conn.prepareStatement(updText);
        stmt.setBinaryStream(1, instream, (int) instream.available());
        stmt.setLong(2, fcChart.getCheckSum());
        stmt.setLong(3, Convert.getCurrentTime());
        stmt.setLong(4, fcId);
        stmt.execute();
        stmt.close();
    }


    public static void main(String[] args) {
        
        Properties properties = new Properties();
        try {
            properties.load(new FileInputStream("db.cf"));
        } catch (IOException e) {
            e.printStackTrace();
        }        
        String url = properties.getProperty("DBASE.URL");
        String password = properties.getProperty("DBASE.PASSWORD");
        String user = properties.getProperty("DBASE.USER");
        System.out.println("URL " + url);
        System.out.println("Password " + password);
        System.out.println("URL " + user);
        
        System.out.println("Fc IDs length " + args.length);
        //System.out.println("Args[0] " + args[0]);

        if (args.length != 1) {
            System.out
                    .println("Please specify fc_id file name in command line");
            System.exit(0);
        }
        File fcIdList = new File(args[0]);
        if (!fcIdList.exists()) {
            System.out
                    .println("List of finding chartt ids file does not exist");
            System.exit(0);
        }
        File f = new File("dummy_finding_chart.jpg");
        if (!f.exists()) {
            System.out.println("JPEG does not exist.");
            System.exit(0);
        }
        try {
            byte[] bData = FileIOUtils.readBinaryFile(f.getAbsolutePath());
            FindingChart fc = new FindingChart();
            CRC32 rc = new CRC32();
            rc.update(bData);
            fc.setFcData(bData);
            fc.setCheckSum(rc.getValue());
            System.out.println("Binary Data Length " + bData.length);
            System.out.println("Checksum " + rc.getValue());

            LineNumberReader reader = new LineNumberReader(new FileReader(
                    fcIdList.getAbsolutePath()));
            Connection con = ConnectionPool.getPool().acquireConnection(url,
                    user,password);
            while (reader.ready()) {
                String s = reader.readLine().trim();
                long fcId = new Long(s).longValue();
                System.out.println("Processing finding chart " + fcId);
                updateFindingChartContents(con, fcId, fc);

            }
            ConnectionPool.getPool().releaseConnection(con);
        } catch (IOException e) {
            System.out.println("Error Reading jpeg file exiting application");
            System.exit(0);
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (ObjectIOException e1) {
             e1.printStackTrace();
        }
    }
}