package org.eso.ohs.phase2.apps.masktracker;

import javax.swing.JMenu;
import javax.swing.JPopupMenu;

import org.apache.log4j.Logger;
import org.eso.ohs.core.dbb.client.DbbPanel;
import org.eso.ohs.core.dbb.client.DbbSelectionList;
import org.eso.ohs.core.dbb.sql.DbbSqlChunk;
import org.eso.ohs.core.dbb.sql.DbbSqlOperator;
import org.eso.ohs.dfs.Mask;
import org.eso.ohs.dfs.MaskQueue;
import org.eso.ohs.phase2.apps.masktracker.actions.InsertionNumberAction;
import org.eso.ohs.phase2.apps.masktracker.actions.InsertionReportAction;

/**
 * The QueueItemsBView class is a DB search engine used for 
 * displaying queues of OBs according to a user-definable set of 
 * properties
 * @author G Passera
 * @author Tim Canavan 
 * @author cmavros Add call to unsubscribe execution action.
 * @author cmavros 1709/OT Call ExecutionSequenceAction 
 *               class to implement progress bar
 *
 * @version $Id: MaskInsertExecSequence.java,v 1.15 2005/12/04 23:50:02 tcanavan Exp $
 *
 * @author cmavros Add call to unsubscribe execution action.
 * @author cmavros 1709/OT Call ExecutionSequenceAction 
 *               class to implement progress bar
 *
 * @version $Id: MaskInsertExecSequence.java,v 1.15 2005/12/04 23:50:02 tcanavan Exp $
 *
 */

public class MaskInsertExecSequence extends MaskExecSequence {

    private static Logger stdlog_ =
	Logger.getLogger(MaskInsertExecSequence.class );
   
  


  /**
   * Default constructor
   *
   */
    public MaskInsertExecSequence(MaskQueue newQueue,MaskQueueView mkView) {
        super(newQueue,null,mkView);
    }


    public void buildRows() {
        super.buildRows();
        DbbSqlOperator op_in = null;
        try {
            op_in = new DbbSqlOperator("in");
        }
        catch( Exception e ) { 
            stdlog_.error( e ); 
        }
        String label_name = "Status";
        String column_name = "mask_status";
        DbbSqlChunk c = new DbbSqlChunk(masks_table, column_name, label_name, op_in, String.class);
        Object[] statusValues = {Mask.MASK_MANUFACTURED,Mask.PENDING_INSERTION,Mask.MASK_INSERTED};
        String[] statusDispValues = {Mask.getDisplayStatusValue(Mask.MASK_MANUFACTURED),
                                     Mask.getDisplayStatusValue(Mask.PENDING_INSERTION),
                                     Mask.getDisplayStatusValue(Mask.MASK_INSERTED)};
        DbbSelectionList status = new DbbSelectionList(label_name, c,statusValues, statusDispValues);
        DbbPanel rowPanel = getRowPanel();
        rowPanel.addWidget(status);
        status.set("(" + "'" + Mask.MASK_MANUFACTURED + "'" + ",'" + Mask.PENDING_INSERTION + ",'" + Mask.MASK_INSERTED + "'"+ ")");
        status.fireDbbWidgetAction();
        view_.setWherePanel(rowPanel, "North");

    }  


   public JPopupMenu createPopupMenu() {
        JPopupMenu popupMenu = new JPopupMenu();    
        JMenu inMenu  = new JMenu("Mask Insertion Order");
        inMenu.add(new InsertionReportAction(view_,true,"Report"));
        inMenu.add(new InsertionNumberAction(view_,true,"Statistics"));
        popupMenu.add(inMenu);
        return popupMenu;
    }

    public void buildToolBar() {
         super.buildToolBar();
         toolBar_.add(selected_);
         //selected_.addActionListener(new ActionListener() {
         //        public void actionPerformed(ActionEvent evt) {
                     //    MaskManufacturing.getInstance().setSingleSelect(selected_.isSelected());
                     // MaskManufacturing.getInstance().setSelectedNaidList(getSelectedMaskNaids());
         //      } 
         //}); 


         selected_.setEnabled(false);
         selected_.setText("Single Selection not availble for insertion");       
    } 
}
