package org.eso.ohs.phase2.apps.masktracker;

import org.apache.log4j.Logger;
import org.eso.ohs.core.dbb.client.DbbSelectionList;
import org.eso.ohs.core.dbb.sql.DbbSqlChunk;
import org.eso.ohs.core.dbb.sql.DbbSqlOperator;
import org.eso.ohs.core.utilities.TextUtils;
import org.eso.ohs.dfs.Mask;
import org.eso.ohs.dfs.Queue;
import org.eso.ohs.phase2.apps.ot.gui.OBTreeView;

/**
 * The QueueItemsBView class is a DB search engine used for 
 * displaying queues of OBs according to a user-definable set of 
 * properties
 * @author G Passera
 * @author Tim Canavan 
 * @author cmavros Add call to unsubscribe execution action.
 * @author cmavros 1709/OT Call ExecutionSequenceAction 
 *               class to implement progress bar
 *
 * @version $Id: MaskManQueueBrowser.java,v 1.16 2005/12/02 15:32:46 tcanavan Exp $
 *
 * @author cmavros Add call to unsubscribe execution action.
 * @author cmavros 1709/OT Call ExecutionSequenceAction 
 *               class to implement progress bar
 *
 * @version $Id: MaskManQueueBrowser.java,v 1.16 2005/12/02 15:32:46 tcanavan Exp $
 *
 */

public class MaskManQueueBrowser extends DefaultMaskBrowser {

    private static Logger stdlog_ =
	Logger.getLogger(MaskManQueueBrowser.class );
  
   


  /**
   * Default constructor
   *
   */
    public MaskManQueueBrowser(Queue newQueue,OBTreeView tree,MaskExecSequence maskExecSequence,MaskQueueView mkView) {
        super(newQueue,tree,maskExecSequence,mkView);     
    }

    public void buildRows() {
        super.buildRows();       
        DbbSqlOperator op_in = null;
        try {
            op_in = new DbbSqlOperator("in");
        }
        catch( Exception e ) { 
            stdlog_.error( e ); 
        }
        String label_name = "Status";
        String column_name = "mask_status";
        DbbSqlChunk c = new DbbSqlChunk(masks_table, column_name, label_name, op_in, String.class);
        Object[] statusValues = {Mask.NO_MASK,Mask.PENDING_MANUFACTURED,Mask.MASK_REMANUFACTURE};
        String[] statusDispValues = {Mask.getDisplayStatusValue(Mask.NO_MASK),
                                     Mask.getDisplayStatusValue(Mask.PENDING_MANUFACTURED),
                                     Mask.getDisplayStatusValue(Mask.MASK_REMANUFACTURE)};
        DbbSelectionList status = new DbbSelectionList(label_name, c,statusValues, statusDispValues);
        rowPanel_.addWidget(status);
        status.set("(" + "'" + TextUtils.quoteSqlString(Mask.NO_MASK) + "'"+ ",'" + 
	               TextUtils.quoteSqlString(Mask.PENDING_MANUFACTURED) + "'" + 
	               ",'" + TextUtils.quoteSqlString(Mask.MASK_REMANUFACTURE) + "'"  + ")");
        //status.getList().addSelectionInterval(0,2);
        status.fireDbbWidgetAction();
	    view_.setWherePanel(rowPanel_, "North");
    }


    /*public JPopupMenu createPopupMenu() {

        JPopupMenu popupMenu = new JPopupMenu();        
     
        JMenu inMenu  = new JMenu("Mask Insertion Order");
        inMenu.add(new InsertionReportAction(view_,true,"All"));
        inMenu.add(new InsertionReportAction(view_,false,"Selected"));
        popupMenu.add(inMenu);

        String menuName = "Mask Statistics";
        JMenu inStatMenu = new JMenu("Mask Insertion Order Statistics");
        inStatMenu.add(new InsertionNumberAction(view_,true,"All"));
        inStatMenu.add(new InsertionNumberAction(view_,false,"Selected"));
        popupMenu.add(inStatMenu);
        return popupMenu;       
        }*/



  
    
    public void buildToolBar() {
        super.buildToolBar();
        //executionAction_ =  new MaskExecAction(this);
    }
  

}
