package org.eso.ohs.phase2.apps.ot;

import org.apache.log4j.Logger;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.dfs.BusinessObject;
import org.eso.ohs.dfs.CalibrationBlock;
import org.eso.ohs.dfs.ConstraintSet;
import org.eso.ohs.dfs.Mask;
import org.eso.ohs.dfs.MaskQueue;
import org.eso.ohs.dfs.ObTargetConstraintInfo;
import org.eso.ohs.dfs.ObservationBlock;
import org.eso.ohs.dfs.ObservationDescription;
import org.eso.ohs.dfs.ObservingRun;
import org.eso.ohs.dfs.Queue;
import org.eso.ohs.dfs.SchedRun;
import org.eso.ohs.dfs.Target;
import org.eso.ohs.dfs.TimeInterval;
import org.eso.ohs.dfs.RunProperties;
import org.eso.ohs.persistence.AppConfig;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.persistence.DirectoryNode;
import org.eso.ohs.persistence.Media;

/**
 * Clearing house for low-level configuration information.
 * 
 * <p>
 * @author cmavros 2002/02/11, 1512/P2PP, add log4j
 * $Id: MyPersistCfg.java,v 1.17 2005/09/15 09:22:13 ddorigo Exp $
 */
// TODO should inherit from apps.DefaultPersistConfig
public class MyPersistCfg extends Config {

    protected static Logger stdlog_ =
        Logger.getLogger( MyPersistCfg.class );

    public String[] folderColumnProperties(Class objType) {
	return AppConfig.getAppConfig().folderColumnProperties(objType);
    }

    public String getDbUserName() {
      return AppConfig.getAppConfig().getDbUserName();	
      //return "ot";			
    }

    public String getDbPassword() {
      return AppConfig.getAppConfig().getDbPassword();
	//return "ntt+vlt"; //"froogal";
    }

		// XXX HACK it needs to read this from a config file
    public String getUrl(String key) {
	return AppConfig.getAppConfig().getUrl(key);   
    }

    public String getDbName(String key) {
        return AppConfig.getAppConfig().getDbName(key);
    }

		// XXX HACK these should go away -- Mea Culpa
    public boolean isOperationsModeId(int uid) {
	return true;
    }

		// XXX HACK these should go away -- Mea Culpa
    public boolean isEngineeringModeId(int uid) {
	return false;
    }

		// XXX HACK these should go away -- Mea Culpa
    public boolean isVisitorModeId(int uid) {
	return false;
    }

		// XXX HACK these should go away -- Mea Culpa
    public boolean isCloneModeId() {
	return false;
    }

		// XXX HACK these should go away -- Mea Culpa
    public boolean isStandardModeId(int uid) {
	return false;
    }


    /**Return true if the userId ==0*/
    public boolean isSuperUser()
    {
    if (getUserName() == 0 )
	return true;
    else
	return false;

    }
    
    
    /**
     * What is the first period for which IP versioning info
     * is expected in the data. 0 indicates no start period, no
     * version info is expected.
     */
    public int getStartPeriodForIPVersioning() {
        int rc = 0;
        if (AppConfig.getAppConfig().isIPVersioningEnabled()) {
            rc = AppConfig.getAppConfig().getIPVersionStartPeriod();
        }
        return rc;
    }
    
    public void initBusObj(Media device,DirectoryNode node,BusinessObject sobj) throws ObjectIOException {
    }   
	
    /**
     * Ask for authentification before action can take place
     * @param device Media referreed to DBASE,LOCAL_STORAGE
     * @exception ObjectIOException Object I/O Excpetion
     */
    public void askForAuthentication(Media device)
				throws ObjectIOException {
	throw new ObjectIOException("The OT doesn't authenticate");
    }


		// XXX Don't know what to do with this -- leave it for a while


    public boolean isUserLevel(Class cls) {
	return cls != null && cls != DirectoryNode.class;
    }       

		// XXX HACK these should go away -- Mea Culpa
    public void initPersistenceObjInfo() {

	//Queue
	ObjConfigPersistence ocp;
      
        ocp = new ObjConfigPersistence(
		Queue.class,
                new String[] {"sch_id","item_name","schedule_type"},
               "schedules","queue",8);
               	       
       objCfgPersistence.put(ocp.key,ocp);

                
                
           ocp = new ObjConfigPersistence(
		MaskQueue.class,
                new String[] {"sch_id","item_name","schedule_type"},
               "schedules","maskqueue",10);
               	       
        objCfgPersistence.put(ocp.key,ocp);
     
        
	ocp = new ObjConfigPersistence(
	    ConstraintSet.class,
	    new String[] {  // Dbase columns for Summary info
		 "cs_id","item_name", "airmass", "moon_distance", "seeing"
	    },
	    "constraint_sets",
	    "cs",
	    4
	);
	objCfgPersistence.put(ocp.key, ocp);

	ocp = new ObjConfigPersistence(
	    Target.class,
	    new String[] {		// Dbase columns for Summary info
		"tp_id", "item_name", "ra", "dec", "equinox", "epoch"
	    },
	    "target_packages",
	    "tp",
	    6
	);
	objCfgPersistence.put(ocp.key, ocp);

	ocp = new ObjConfigPersistence(
	    ObservationBlock.class,
	    new String[] {		// Dbase columns for Summary info
		"obs_blocks.ob_id", "obs_blocks.item_name",
		    "status", "target_packages.item_name",
		    "obs_descriptions.item_name"
	    },
	    "obs_blocks, target_packages, obs_descriptions",
	    "ob",
	    3
	);
	objCfgPersistence.put(ocp.key, ocp);

	ocp = new ObjConfigPersistence(
	    CalibrationBlock.class,
	    new String[] {		// Dbase columns for Summary info
		"obs_blocks.ob_id", "obs_blocks.item_name",
		    "status", "obs_descriptions.item_name"
	    },
	    "obs_blocks, obs_descriptions",
	    "cb",
	    7
	);
	objCfgPersistence.put(ocp.key, ocp);

	ocp = new ObjConfigPersistence(
	    ObservationDescription.class,
	    new String[] {		// Dbase columns for Summary info
		"od_id", "item_name", "instrument"
	    },
	    "obs_descriptions",
	    "od",
	    2
	);
	objCfgPersistence.put(ocp.key, ocp);

	ocp = new ObjConfigPersistence(
	    ObservingRun.class,
	    new String[] {		// Dbase columns for Summary info
		"obs_runs.id", "obs_programmes.title"
	    },
	    "obs_runs, sched_rep, obs_programmes, eso_users, proposed",
	    "or",
	    5
	);
	objCfgPersistence.put(ocp.key, ocp);

	ocp = new ObjConfigPersistence(
	    DirectoryNode.class,
	    new String[] {		// Dbase columns for Summary info
	    },
	    "",
	    "dir",
	    0
	);
	objCfgPersistence.put(ocp.key, ocp);

	ocp = new ObjConfigPersistence(
	    Mask.class,
	    new String[] {		// Dbase columns for Summary info
		"masks.ob_id", "masks.ts_index",
		    "masks.param_index", "masks.mask_naid",
		    "masks.bar_code", "masks.mask_slot_num"
	    },
	    "masks",
	    "msk",
	    12
	);
	objCfgPersistence.put(ocp.key, ocp);
	
	ocp = new ObjConfigPersistence(
	    ObTargetConstraintInfo.class,
	    new String[] {},
	    "",
	    "",
	    13
	);
    
    objCfgPersistence.put(ocp.key, ocp);    
    
    ocp = new ObjConfigPersistence(
            TimeInterval.class,
            new String[] {},
            "",
            "",
            14
        );  

    objCfgPersistence.put(ocp.key, ocp);
 
        ocp = new ObjConfigPersistence(
                SchedRun.class,
                new String[] {},
                "",
                "",
                15
            );
            objCfgPersistence.put(ocp.key, ocp);
            
            ocp = new ObjConfigPersistence(
                    RunProperties.class,
                    new String[] {},
                    "",
                    "",
                    16
                );
                objCfgPersistence.put(ocp.key, ocp);

            
        
    }
}


