package org.eso.ohs.phase2.apps.ot;

import java.util.EventListener;

import org.eso.ohs.phase2.apps.ot.gui.SummaryTableEvent;

/**
 * Interface implemented by listeners on object table events.
 * 
 * <p>
 * $Id: ObjectTableListener.java,v 1.3 2003/07/03 08:49:49 ddorigo Exp $
 * <br>
 * @author Bob Kemp
 */
public interface ObjectTableListener extends EventListener {

    /** 
     * "Object added" event handler.
     * 
     * @param ev    Event giving more specific details
     */
    public void tableObjectAdded(SummaryTableEvent ev);

    /**
     * Method to call when an attribute of the object has changed.
     * 
     * @param ev    Event giving more specific details,
     *		    such as which object has changed.
     */
    public void tableObjectChanged(SummaryTableEvent ev);

    /**
     * "Object removed" event handler.
     *
     * @param ev    Event giving more specific details
     */
    public void tableObjectRemoved(SummaryTableEvent ev);

}

