package org.eso.ohs.phase2.apps.ot.actions;

import java.awt.event.ActionEvent;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.gui.widgets.ErrorMessages;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.dfs.CalibrationBlock;
import org.eso.ohs.dfs.ObservingRun;
import org.eso.ohs.dfs.Readme;
import org.eso.ohs.dfs.USDReadmeDatails;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.persistence.Media;
import org.eso.ohs.persistence.OHSPersistence;
import org.eso.ohs.persistence.ObjectContainer;
import org.eso.ohs.persistence.ObjectNotFoundException;
import org.eso.ohs.persistence.dbase.phase2.USDFileDBIO;
import org.eso.ohs.phase2.apps.ot.gui.ReadmeNotesDialog;

/**
* Class ChileNotesReadme
* 
* TODO Javadoc
* 
* @version $Revision: 1.2 $
* @author tcanavan, Feb 21, 2005
*/

//$Id: ChileNotesReadmeAction.java,v 1.2 2005/05/10 10:11:34 tcanavan Exp $
public class ChileNotesReadmeAction extends ActionSuperclass {

   private ObjectContainer objectContainer_;


   /**
    * @param comp
    * @param name
    */
   public ChileNotesReadmeAction(ObjectContainer objectContainer, String name) {
       super((JComponent)objectContainer, name);
       objectContainer_ = objectContainer;
       // TODO Auto-generated constructor stub
   }

   /*
    * (non-Javadoc)
    * 
    * @see org.eso.ohs.core.gui.baseaction.ActionSuperclass#actionPerformedImpl(java.awt.event.ActionEvent)
    */
   public void actionPerformedImpl(ActionEvent ev) {
       JFrame frm  = (JFrame)objectContainer_.getTopLevelAncestor();
       OHSPersistence persistence = (OHSPersistence) OHSPersistence
               .getObjectManager();
       Long idVal = objectContainer_.getSelected();
       if (idVal == null || idVal.longValue() == -1) {
           JOptionPane.showMessageDialog(frm,
                   new Object[] { "No OB Selected." }, "No OB Selected",
                   JOptionPane.ERROR_MESSAGE);
           return;
       }
       Class objType = Config.getCfg().getClassFromId(idVal.longValue());
       CalibrationBlock cb;
       try {
           cb = (CalibrationBlock) persistence.getBusObj(Media.PHASE2_DB,
                   idVal.longValue(), objType);

           if (cb == null) {
               JOptionPane.showMessageDialog(frm,
                       new Object[] { "No OB Selected." }, "No OB Selected",
                       JOptionPane.ERROR_MESSAGE);
               return;
           }
           ObservingRun obsRun = cb.getObsRun();
           Readme readme = persistence.populateReadmeFileReplicate(Media.PHASE2_DB,
                   obsRun);
           USDReadmeDatails usdReadmeFileDetails = readme
                   .getUsdReadmeFileDetails();
           String observatoryNotes = usdReadmeFileDetails.getObservatoryNotes();
           ReadmeNotesDialog dlg = new ReadmeNotesDialog(frm);
           if(observatoryNotes != null)
               dlg.setReadmeNotes(observatoryNotes);
           dlg.show();
           String notes = dlg.getReadmeNotes();
           if (dlg.getUserChoice() == JOptionPane.OK_OPTION) {
               if(notes != null && notes.length() > 0)
                   USDFileDBIO.updateObservatoryNotes(notes,Config.getCfg().uniqueToTableId(obsRun.getId()));
           } else {
               if(notes != null && !notes.equals(observatoryNotes)) {
                   int n =
                       JOptionPane.showConfirmDialog(
                           frm,
                           "Readne Notes has been edited. Do you wish to save ?",
                           "Save",
                           JOptionPane.YES_NO_OPTION);
                   if(n == JOptionPane.YES_OPTION) {
                       USDFileDBIO.updateObservatoryNotes(notes,Config.getCfg().uniqueToTableId(obsRun.getId()));                        
                   }
               }

           }
       } catch (ObjectNotFoundException e) {
           ErrorMessages.announceNoObject(frm, e);
       } catch (ObjectIOException e) {
           ErrorMessages.announceIOError(frm,e);
       }
   }
}

