package org.eso.ohs.phase2.apps.ot.actions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JTable;

import org.eso.ohs.core.gui.widgets.ErrorMessages;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.dfs.CalibrationBlock;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.persistence.Media;
import org.eso.ohs.persistence.ObjectManager;
import org.eso.ohs.persistence.ObjectNotFoundException;
import org.eso.ohs.phase2.apps.ot.gui.OBTreeView;
import org.eso.ohs.phase2.apps.ot.gui.OTQueueBrowserView;
public class DisplayOBAction extends AbstractAction {

    private OTQueueBrowserView queueBrowserView_;

    private OBTreeView treeView_;

    private JTable table_;

    public DisplayOBAction(OTQueueBrowserView queueBrowserView,OBTreeView treeView) {
        super("Display");
        queueBrowserView_ = queueBrowserView;
        treeView_ = treeView;
	table_ = queueBrowserView_.getView().getTable().getTable();
    }

    public void actionPerformed(ActionEvent ev) {    
        long[] selectedOBsId = queueBrowserView_.getSelectedOBIDs( true); 
        if (selectedOBsId.length > 0) {
	    try {
		CalibrationBlock cb = null;
		ObjectManager objMgr = ObjectManager.getObjectManager();
		Class c = queueBrowserView_.getView().getClassForId(Config.getCfg().uniqueToTableId(selectedOBsId[0]));        
		cb = (CalibrationBlock)objMgr.getBusObj(Media.DBASE,
					     selectedOBsId[0],
					     c);         
		treeView_.updateView(cb);
	    }
	    catch (ObjectIOException ex) {
	        ErrorMessages.announceIOError(table_,ex);
	    }
		    
	    catch (ObjectNotFoundException ex) {
	        ErrorMessages.announceNoObject(table_,ex);
	    }
        
	}
    }

}
