package org.eso.ohs.phase2.apps.ot.actions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import org.eso.ohs.persistence.Config;
import org.eso.ohs.persistence.ObjectContainer;
import org.eso.ohs.phase2.obHistory.DbWin;

/**
 * Action class to open an OB history browser
 *
 * @author tcanavan
 * @version $Revision: 1.5 $
 */
public class OBHistoryAction extends AbstractAction {

    private long dbId = -1;
    private ObjectContainer queueBrowserView_ = null;

    public OBHistoryAction(ObjectContainer queueBrowserView) {
        super("OB History");
        queueBrowserView_ = queueBrowserView;
    }

    /**
     * Constructor for OBHistoryAction.
     * @param comp
     * @param name
     */
    public OBHistoryAction(String name) {
        super(name);
    }

    /**
     *
     * @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
     */
    public void actionPerformed(ActionEvent arg0) {
        if (queueBrowserView_ != null) {
            long obId = queueBrowserView_.getSelected().longValue();
            if(obId != -1) {
                dbId = Config.getCfg().uniqueToTableId(obId);                
            } else {
                dbId = -1;
            }
        }
        DbWin dbWin = DbWin.getInstance((int)dbId);
        dbWin.show();
    }
}

