package org.eso.ohs.phase2.apps.ot.actions;

import java.awt.event.ActionEvent;

import javax.swing.JFrame;

import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.persistence.ObjectContainer;
import org.eso.ohs.persistence.dbase.phase2.QueueManager;
import org.eso.ohs.phase2.apps.ot.wizard.OrangEngine;
import org.eso.ohs.phase2.apps.ot.wizard.OrangWizard;

/**
 * Action class to start the Orang Wizard.
 * 
 * <p>
 * $Id: OrangStartAction.java,v 1.8 2005/12/05 09:09:58 ddorigo Exp $ <br>
 * 
 * @author Dario Dorigo
 */

public class OrangStartAction extends ActionSuperclass {

 
    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    private OrangEngine orang = null;

    private JFrame frm_;

 
    /**
     * Set the memeber variables.
     */
    public OrangStartAction(ObjectContainer objContainer, JFrame frm,
            String name) {
        super(frm, name);
        frm_ = frm;
        // OrangEngine created as singleton because the QueueManager 
        // is a singleton and it would keep the reference to the listener
        // till the closing of the application.
        // OrangEngine listens to ob execution events.
        if (orang == null) {
            orang = new OrangEngine();
            QueueManager.addOBListener(orang);   
        }
    }

    /**
     * Event handler for the action.
     * 
     * 
     * @param ev user-initiated ActionEvent to quit.
     */
    public void actionPerformedImpl(ActionEvent evt) {
        StartWizardSubThread wizard = new StartWizardSubThread();  
        Thread newThread = new Thread(wizard);
        newThread.start();
    }

    /**
     * Class StartWizardSubThread
     *
     * Run the wizard in anothere subthread in order 
     * to have a non modal behavior 
     *
     * @version $Revision: 1.8 $
     * @author ddorigo, Nov 3, 2005
     */
    
    // $Id: OrangStartAction.java,v 1.8 2005/12/05 09:09:58 ddorigo Exp $
    public class StartWizardSubThread implements Runnable {
        public void run() {  
            OrangWizard orangWizard = new OrangWizard(orang);
            orangWizard.showWizard(frm_, "ORANG Wizard", false);      
        }
    }
}
