package org.eso.ohs.phase2.apps.ot.gui;

import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import org.eso.ohs.core.gui.widgets.SwingFileChooser;


/** 
 * QueueChooser provides a simple mechanism for the user to chooser a 
 * Queue available in the DB
 * @author  G.Passera, DMD/ESO, <gpassera@eso.org>
 */

public class TextView extends JFrame {

    public  JButton closeButton;
    public  JButton saveButton;
    public  JButton printButton;
    private JTextArea  textArea;
    private String     text;
    private JFileChooser jfc = new SwingFileChooser();
   


    /** 
     *Default constructor. 
     *Creates a QueueChooserView
     */
    public TextView (String newText) 
    {
    super("Queues holding OB");
    text = newText;
    init();
    pack();
    setVisible(true);
    }

    

    /**Initialyze the view*/
    private void init() 
    {
    closeButton   = new JButton("Close");
    saveButton    = new JButton("Save");
    printButton   = new JButton("Print");

    textArea = new JTextArea(text);
    JScrollPane scrollPane = new JScrollPane(textArea);
    
    
    
    //builds the panel layout
    JPanel content = new JPanel();
    content.setLayout(new GridBagLayout());
    Container c = (Container) content;
    
    GridBagAdder.add(c,scrollPane,0,0,5,1,1,1,GridBagConstraints.BOTH,
                     GridBagConstraints.CENTER);
    GridBagAdder.add(c,closeButton,0,1,1,1,0,0,GridBagConstraints.BOTH,
                     GridBagConstraints.CENTER);
    GridBagAdder.add(c,saveButton,1,1,1,1,0,0,GridBagConstraints.BOTH,
                     GridBagConstraints.CENTER);
    GridBagAdder.add(c,new JLabel(),2,1,1,1,1,0,GridBagConstraints.BOTH,
                     GridBagConstraints.CENTER);
    GridBagAdder.add(c,printButton,4,1,1,1,0,0,GridBagConstraints.BOTH,
                     GridBagConstraints.CENTER);

    getContentPane().add(c);
    //

    printButton.addActionListener( new ActionListener() 
	{
	public void actionPerformed(ActionEvent e) 
	    {
	      //dispose();
	    }
	});

    

    saveButton.addActionListener( new ActionListener() 
	{
	public void actionPerformed(ActionEvent e) 
	  {
	  int returnVal = jfc.showSaveDialog(null); 
	  if(returnVal == JFileChooser.APPROVE_OPTION)
	    {
	    try 
	      {
	      
	      FileWriter fw = new FileWriter(jfc.getSelectedFile());
	      fw.write(text);
	      fw.close();
	      }
	    
	    catch (IOException ex)
	      {
	      String message = "An error occured while writing file " + 
		    jfc.getSelectedFile();
	      JOptionPane.showMessageDialog(null,message,
			   "I/O Error", JOptionPane.ERROR_MESSAGE);	
	      ex.printStackTrace();
	      }
	    }
	  }
	});

    
    closeButton.addActionListener( new ActionListener() 
	{
	public void actionPerformed(ActionEvent e) 
	  {
	  dispose();
	  }
	});
   

    }


 







}

    

    
    










