package org.eso.ohs.phase2.icdVcs;

import java.util.EventListener;


/**
 * Listener for script events from the BOB interface
 * 
 * <p>
 * NOTE: This class must be public in order for Java/Ccs to work.
 *       I'm not sure of the reason but it's probably to do with
 *       their use of the Reflection API.
 * 
 * <p>
 * $Id: ScriptCmdListener.java,v 1.3 2003/07/03 08:49:49 ddorigo Exp $
 * <br>
 * @author Bob Kemp
 */
public interface ScriptCmdListener extends EventListener {

    public static final int ALL_AVAILABLE = Integer.MAX_VALUE;

    /**
     * Handler method for NextObsBlocks requests from BOB.
     * 
     * @param numOBs	Number of OBs to be transferred
     * @param isOffline	Boolean.TRUE if is offline request,
     *			Boolean.FALSE if is not an offline request
     *			null if unspecified
     * 
     * @return		Observation block in OBD format 
     *		    	or null string if an error occurred.
     */
    public String NextObsBlocks(int numOBs, Boolean isOffline);

}


