package org.eso.ohs.phase2.visibility;

/**
 * A PCFPlotterFilter extension for plotting moon down (or up). The class accepts
 * a constraint value, and uses this to return a value of either 1 (the
 * the moon is below the horizon) or 0 (the moon is above the horizon). 
 *
 * @author Nick Kornweibel for ESO.
 */

public class MoonDownFilter extends PCFPlotterFilter {

    public MoonDownFilter() {
        // nothing to do.
    }

    public double input(PCFInterval interval)
            throws PCFPlotterFilter.ValueRejectedException {
        double rc;
        if (interval.getValue() == 0.0) {
            // 1.0 indicates the moon is DOWN (moon is down when 0.0 is interval value)
            rc = 1.0;
        } else {
            // 0.0 indicates the moon is UP (moon is up when 1.0 is interval value).
            rc = 0.0;
        }
        return rc;
    }
}
