package org.eso.ohs.scripting;

/**
 * The TimeIntervalAPI is an interface to a Time Interval specified with in
 * an OB.
 *
 * IMPORTANT: Changes to this interface must result in a new version string 
 * in the ScriptingBox class.
 *
 * @author Nick Kornweibel
 */

public interface TimeIntervalAPI {

    /**
     * Get the name of this time interval
     * @return string containing name of time interval
     */

    public String getName();

    /**
     * Get the id of this time interval
     * @return string containing the id of this time interval
     */

    public String getId();

    /**
     * Get the start time
     * @return the start time
     */

    public long getStartTime();

    /**
     * Get the end time
     * @return end time
     */

    public long getEndTime();

    /**
     * Get the preference
     * @return preference
     */

    public int getPreference();

}
